﻿@using Google.Authenticator
@using System.Security.Claims
@using System.Web
@{
    ViewData["Title"] = "Security Setting";
    SetupCode SetupCode = ViewBag.SetupCode;
    bool HasTwoFactorAuth = ViewBag.HasTwoFactorAuth;
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="card-header flex-wrap border-0 p-0">
                <div class="card-title mb-0">
                    <div class="d-flex justify-content-between">
                        <div>
                            <h3 class="card-label text-primary">
                                Settings
                            </h3>
                        </div>
                        <div>
                            <button class="btn btn-secondary font-weight-bold px-6 py-2" id="save-exit-setting">Save & Exit</button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-2 border-right">
                    <partial name="_SettingsNavBar" />
                </div>
                <div class="col-md-10">
                    <div id="wizard-content">
                        <div id="msg" class="mt-2"></div>
                        <div class="row">
                            <div class="col-md-6">
                                <form action="adviser/settings/savetwofactorauth" class="form" id="frm-two-factor-auth" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="onFormComplete2StepVerification">
                                    <div class="card-body p-0">
                                        <div class="row">
                                            <div class="col-md-8">
                                                <div class="form-group">
                                                    <label>Email</label>
                                                    <input class="form-control form-control-lg" value="@HttpUtility.UrlDecode(SetupCode.Account)" disabled>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class="d-flex">
                                                <div class="align-self-center mr-2">
                                                    <span class="switch switch-icon switch-sm switch-custom">
                                                        <label>
                                                            <input id="TwoFactorAuth" type="checkbox" name="TwoFactorAuth" checked="@(HasTwoFactorAuth ? "checked" : null)" value="true" />
                                                            <span></span>
                                                        </label>
                                                    </span>
                                                </div>
                                                <label class="col-form-label switch-label">
                                                    2-Step Verification
                                                </label>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-8">
                                                <div class="form-group">
                                                    <label>Setup Key</label>
                                                    <textarea id="SecurityKey" class="form-control form-control-lg" rows="2" disabled style="resize:none">@SetupCode.ManualEntryKey</textarea>
                                                </div>
                                                <div class="form-group">
                                                    <label>Verification Code</label>
                                                    <input class="form-control form-control-lg required" id="VerificationCode" name="VerificationCode" maxlength="6">
                                                </div>
                                            </div>
                                            <div class="col-md-4" id="QrCode-container">
                                                <img src="@SetupCode.QrCodeSetupImageUrl" class="w-100" />
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="col-md-6 bg-light-primary mt-3 p-8" id="two-factor-auth-help">
                                <partial name="TwoFactorAuthHelp" />
                            </div>
                        </div>
                        <partial name="_SettingWizardFooter" />
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<style>
    .navi.navi-active .navi-item .navi-link.active {
        background-color: #E1F0FF;
    }
</style>
@section scripts{
    <script>
        $("#save-exit-setting").click(function () {
            $("#FromExitButton").val("1");
        })
        $("#btn-back").addClass("invisible");
        $("#frm-two-factor-auth").validate({
            messages: {
                VerificationCode: "Provide Verification Code"
            }
        });
        var showHideTwoFactorAuth = function(hasTwoFactorAuth, init) {
            $("#SecurityKey").closest(".form-group").addClass("d-none");
            $("#VerificationCode").closest(".form-group").addClass("d-none");
            $("#QrCode-container").addClass("d-none");
            $("#two-factor-auth-help").addClass("d-none");
            $(".alert").remove();
            if (hasTwoFactorAuth) {
                $("#SecurityKey").closest(".form-group").removeClass("d-none");
                $("#QrCode-container").removeClass("d-none");
                $("#two-factor-auth-help").removeClass("d-none");
                if (init)
                    $("#btn_submit_2step").prop("disabled", true);
                else
                    $("#VerificationCode").val(null).closest(".form-group").removeClass("d-none");
            }
            else {
                $("#btn_submit_2step").prop("disabled", true);
                _showFormMessage("msg", "warning", "It is advisable to follow the 2 Step Verification process from the Security point of view", "fas fa-exclamation-triangle");
            }
        }
        var onFormComplete2StepVerification = function(response) {
            $(".alert").remove();
            var fromExitButton = $("#FromExitButton").val() == "1";
            var id = fromExitButton ? "save-exit-setting" : "btn-submit";
            var btn = KTUtil.getById(id);
            var frm_id = $(this).attr('id');
            var responseObj = JSON.parse(response.responseText);
            if (responseObj.success) {
                $("#TwoFactorAuth").prop("checked", responseObj.data.twoFactorAuth);
                var hasTwoFactorAuth = $("#TwoFactorAuth").is(":checked");
                showHideTwoFactorAuth(hasTwoFactorAuth, true);
                toastr.options = toastrOptions;
                if (hasTwoFactorAuth && responseObj.message)
                    toastr.success(responseObj.message);
                else
                    responseObj.message && toastr.warning(responseObj.message);
                if (responseObj.redirectUrl)
                    window.location.href = fromExitButton ? "@area/client-list" : responseObj.redirectUrl;
            }
            else
                _showFormMessage(frm_id, "danger", responseObj.message, "fas fa-exclamation-triangle");
            KTUtil.btnRelease(btn);
            $("#btn_submit_2step").prop("disabled", true);
        };
        $("#TwoFactorAuth").change(function() {
            var hasTwoFactorAuth = $(this).is(":checked");
            showHideTwoFactorAuth(hasTwoFactorAuth);
            $("#btn_submit_2step").prop("disabled", false);
        });        
        var hasTwoFactorAuth = '@HasTwoFactorAuth' == "True";
        showHideTwoFactorAuth(hasTwoFactorAuth, true);
        $("#save-exit-setting,#btn-submit").click(function(e) {
            e.preventDefault();
            if ($("#frm-two-factor-auth").valid()) {
                var btn = KTUtil.getById(e.target.id);
                var spinnerClass = e.target.id == "btn-complete" ? "white" : "dark";
                KTUtil.btnWait(btn, `spinner spinner-right spinner-${spinnerClass} pr-15`, "Please wait");
                $("#frm-two-factor-auth").submit();
            }
        });
    </script>
    }